git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: "brian m. carlson" <sandals@crustytoothpaste.net>
To: <git@vger.kernel.org>
Cc: Johannes Schindelin <Johannes.Schindelin@gmx.de>
Subject: [PATCH 04/38] t3404: prepare 'short SHA-1 collision' tests for SHA-256
Date: Fri, 10 Jul 2020 02:46:54 +0000	[thread overview]
Message-ID: <20200710024728.3100527-5-sandals@crustytoothpaste.net> (raw)
In-Reply-To: <20200710024728.3100527-1-sandals@crustytoothpaste.net>

From: Johannes Schindelin <johannes.schindelin@gmx.de>

The idea of the magic value "ac4f2ee" in this test is to make the
reworded commit `collide2` have the same shortened ID as the commit
`collide3`.

To port the same idea to the SHA-256 version of Git, we therefore need
another magic value that causes the same collision, but this time with
the SHA-256 version of the commit IDs.

In this patch, we add code guarded by `GIT_TEST_FIND_COLLIDER` to do
exactly that. Essentially, a large number of integers is appended to the
commit message "collide2" to find such a collision. To make it easier to
find such a collision, we reduce the number of digits to 4.

The `t/oid-info/oid` file now lists the values found in that way, and
the test cases are modified to use those values.

As the tests are no longer dependent on SHA-1, we also rename their
titles to talk about "commit IDs" instead of "SHA-1s".

Signed-off-by: Johannes Schindelin <johannes.schindelin@gmx.de>
Signed-off-by: brian m. carlson <sandals@crustytoothpaste.net>
---
 t/t3404-rebase-interactive.sh | 50 ++++++++++++++++++++++++++++-------
 1 file changed, 41 insertions(+), 9 deletions(-)

diff --git a/t/t3404-rebase-interactive.sh b/t/t3404-rebase-interactive.sh
index 4a7d21f898..2fb2c581cb 100755
--- a/t/t3404-rebase-interactive.sh
+++ b/t/t3404-rebase-interactive.sh
@@ -30,6 +30,7 @@ Initial setup:
 . "$TEST_DIRECTORY"/lib-rebase.sh
 
 test_expect_success 'setup' '
+	test_oid_init &&
 	test_commit A file1 &&
 	test_commit B file1 &&
 	test_commit C file2 &&
@@ -1250,7 +1251,7 @@ test_expect_success 'rebase -i error on commits with \ in message' '
 	test_expect_code 1 grep  "	emp" error
 '
 
-test_expect_success SHA1 'short SHA-1 setup' '
+test_expect_success 'short commit ID setup' '
 	test_when_finished "git checkout master" &&
 	git checkout --orphan collide &&
 	git rm -rf . &&
@@ -1262,23 +1263,54 @@ test_expect_success SHA1 'short SHA-1 setup' '
 	)
 '
 
-test_expect_success SHA1 'short SHA-1 collide' '
+if test -n "$GIT_TEST_FIND_COLLIDER"
+then
+	author="$(unset test_tick; test_tick; git var GIT_AUTHOR_IDENT)"
+	committer="$(unset test_tick; test_tick; git var GIT_COMMITTER_IDENT)"
+	blob="$(git rev-parse collide2:collide)"
+	from="$(git rev-parse collide1^0)"
+	repl="commit refs/heads/collider-&\\n"
+	repl="${repl}author $author\\ncommitter $committer\\n"
+	repl="${repl}data <<EOF\\ncollide2 &\\nEOF\\n"
+	repl="${repl}from $from\\nM 100644 $blob collide\\n"
+	test_seq 1 32768 | sed "s|.*|$repl|" >script &&
+	git fast-import <script &&
+	git pack-refs &&
+	git for-each-ref >refs &&
+	grep "^$(test_oid t3404_collision)" <refs >matches &&
+	cat matches &&
+	test_line_count -gt 2 matches || {
+		echo "Could not find a collider" >&2
+		exit 1
+	}
+fi
+
+test_expect_success 'short commit ID collide' '
+	test_oid_cache <<-EOF &&
+	# collision-related constants
+	t3404_collision	sha1:6bcd
+	t3404_collision	sha256:0161
+	t3404_collider	sha1:ac4f2ee
+	t3404_collider	sha256:16697
+	EOF
 	test_when_finished "reset_rebase && git checkout master" &&
 	git checkout collide &&
-	colliding_sha1=6bcda37 &&
-	test $colliding_sha1 = "$(git rev-parse HEAD | cut -c 1-7)" &&
+	colliding_id=$(test_oid t3404_collision) &&
+	hexsz=$(test_oid hexsz) &&
+	test $colliding_id = "$(git rev-parse HEAD | cut -c 1-4)" &&
+	test_config core.abbrev 4 &&
 	(
 		unset test_tick &&
 		test_tick &&
 		set_fake_editor &&
-		FAKE_COMMIT_MESSAGE="collide2 ac4f2ee" \
+		FAKE_COMMIT_MESSAGE="collide2 $(test_oid t3404_collider)" \
 		FAKE_LINES="reword 1 break 2" git rebase -i HEAD~2 &&
-		test $colliding_sha1 = "$(git rev-parse HEAD | cut -c 1-7)" &&
-		grep "^pick $colliding_sha1 " \
+		test $colliding_id = "$(git rev-parse HEAD | cut -c 1-4)" &&
+		grep "^pick $colliding_id " \
 			.git/rebase-merge/git-rebase-todo.tmp &&
-		grep "^pick [0-9a-f]\{40\}" \
+		grep "^pick [0-9a-f]\{$hexsz\}" \
 			.git/rebase-merge/git-rebase-todo &&
-		grep "^pick [0-9a-f]\{40\}" \
+		grep "^pick [0-9a-f]\{$hexsz\}" \
 			.git/rebase-merge/git-rebase-todo.backup &&
 		git rebase --continue
 	) &&

  parent reply	other threads:[~2020-07-10  2:48 UTC|newest]

Thread overview: 50+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2020-07-10  2:46 [PATCH 00/38] SHA-256, part 3/3 brian m. carlson
2020-07-10  2:46 ` [PATCH 01/38] t: make test-bloom initialize repository brian m. carlson
2020-07-10  2:46 ` [PATCH 02/38] t1001: use $ZERO_OID brian m. carlson
2020-07-10  2:46 ` [PATCH 03/38] t3305: make hash agnostic brian m. carlson
2020-07-10  2:46 ` brian m. carlson [this message]
2020-07-10  2:46 ` [PATCH 05/38] t6100: make hash size independent brian m. carlson
2020-07-10  2:46 ` [PATCH 06/38] t6101: " brian m. carlson
2020-07-10  2:46 ` [PATCH 07/38] t6301: " brian m. carlson
2020-07-10  2:46 ` [PATCH 08/38] t6500: specify test values for SHA-256 brian m. carlson
2020-07-10  2:46 ` [PATCH 09/38] t6501: avoid hard-coded objects brian m. carlson
2020-07-10  2:47 ` [PATCH 10/38] t7003: compute appropriate length constant brian m. carlson
2020-07-10  2:47 ` [PATCH 11/38] t7063: make hash size independent brian m. carlson
2020-07-11  0:43   ` Junio C Hamano
2020-07-11  0:54     ` brian m. carlson
2020-07-10  2:47 ` [PATCH 12/38] t7201: abstract away SHA-1-specific constants brian m. carlson
2020-07-10  2:47 ` [PATCH 13/38] t7102: " brian m. carlson
2020-07-10  2:47 ` [PATCH 14/38] t7400: make hash size independent brian m. carlson
2020-07-10  2:47 ` [PATCH 15/38] t7405: " brian m. carlson
2020-07-10  2:47 ` [PATCH 16/38] t7506: avoid checking for SHA-1-specific constants brian m. carlson
2020-07-10  2:47 ` [PATCH 17/38] t7508: use $ZERO_OID instead of hard-coded constant brian m. carlson
2020-07-10  2:47 ` [PATCH 18/38] t8002: make hash size independent brian m. carlson
2020-07-10  2:47 ` [PATCH 19/38] t8003: " brian m. carlson
2020-07-10  2:47 ` [PATCH 20/38] t8011: " brian m. carlson
2020-07-10  2:47 ` [PATCH 21/38] t9300: abstract away SHA-1-specific constants brian m. carlson
2020-07-10  2:47 ` [PATCH 22/38] t9300: use $ZERO_OID instead of hard-coded object ID brian m. carlson
2020-07-10  2:47 ` [PATCH 23/38] t9301: make hash size independent brian m. carlson
2020-07-10  2:47 ` [PATCH 24/38] t9350: " brian m. carlson
2020-07-10  2:47 ` [PATCH 25/38] t9500: ensure that algorithm info is preserved in config brian m. carlson
2020-07-10  2:47 ` [PATCH 26/38] t9700: make hash size independent brian m. carlson
2020-07-10  2:47 ` [PATCH 27/38] t5308: make test work with SHA-256 brian m. carlson
2020-07-10  2:47 ` [PATCH 28/38] t0410: mark test with SHA1 prerequisite brian m. carlson
2020-07-10  2:47 ` [PATCH 29/38] http-fetch: set up git directory before parsing pack hashes brian m. carlson
2020-07-10  2:47 ` [PATCH 30/38] builtin/verify-pack: implement an --object-format option brian m. carlson
2020-07-10  2:47 ` [PATCH 31/38] setup: add support for reading extensions.objectformat brian m. carlson
2020-07-10  2:47 ` [PATCH 32/38] Enable SHA-256 support by default brian m. carlson
2020-07-10  2:47 ` [PATCH 33/38] t: add test_oid option to select hash algorithm brian m. carlson
2020-07-10  2:47 ` [PATCH 34/38] t: allow testing different hash algorithms via environment brian m. carlson
2020-07-10  2:47 ` [PATCH 35/38] t: make SHA1 prerequisite depend on default hash brian m. carlson
2020-07-12  2:13   ` Denton Liu
2020-07-12 17:34     ` Junio C Hamano
2020-07-10  2:47 ` [PATCH 36/38] ci: run tests with SHA-256 brian m. carlson
2020-07-10 15:09   ` Derrick Stolee
2020-07-10  2:47 ` [PATCH 37/38] docs: add documentation for extensions.objectFormat brian m. carlson
2020-07-10 20:21   ` Martin Ågren
2020-07-10  2:47 ` [PATCH 38/38] t: remove test_oid_init in tests brian m. carlson
2020-07-10 15:14 ` [PATCH 00/38] SHA-256, part 3/3 Derrick Stolee
2020-07-10 19:55   ` brian m. carlson
2020-07-10 20:15     ` Junio C Hamano
2020-07-11  0:37     ` Junio C Hamano
2020-07-11  1:06       ` brian m. carlson

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=20200710024728.3100527-5-sandals@crustytoothpaste.net \
    --to=sandals@crustytoothpaste.net \
    --cc=Johannes.Schindelin@gmx.de \
    --cc=git@vger.kernel.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).